import { Grid} from "@mui/material";
import { memo, useEffect, useState } from "react";

const CalendarStandartCell = ({children, xs, hours, dayNumber,  createTaskInCellHandler, handleOpen, modal}) => {
    const [isThisCell, setIsThisCell] = useState(false)
    useEffect(()=>{
        if(!modal) {
            setIsThisCell(false);
        }
    }, [modal])
    return <>
        <Grid  
            item xs={xs} 
            sx={{borderRight: '1px solid black'}} 
            onClick={(e)=>{createTaskInCellHandler(dayNumber, hours); setIsThisCell(true); handleOpen(e)}}>
            {children}
        {isThisCell ?  
        <Grid  
            sx={{height: '30px', backgroundColor: 'lightgreen', whiteSpace: 'nowrap', overflow: 'hidden', textOverflow: 'ellipsis', padding: '5px', margin:"5px 10px", borderRadius: '10px'}} 
            >
            <span>
                Задача
            </span>
        </Grid> : null}
        </Grid>
    </>
};

export default memo(CalendarStandartCell,  (prevProps, nextProps)=>{
    if(!prevProps.modal) return false
    if(nextProps.modal) return true
  });